=== examples/Kaleidoscope/Chapter5/CMakeLists.txt ===
set(LLVM_LINK_COMPONENTS
  Analysis
  Core
  ExecutionEngine
  InstCombine
  Object
  OrcJIT
  Passes
  RuntimeDyld
  ScalarOpts
  Support
  native
  )

add_kaleidoscope_chapter(Kaleidoscope-Ch5
  toy.cpp
  )

export_executable_symbols(Kaleidoscope-Ch5)
